#include <windows.h>
#include <stdio.h>


struct ARCINFO{
	DWORD	offset;
	DWORD	size;
	char*	name;
};

// t@CXg(iver1.02b)
ARCINFO		DatInfo[] = {
	{0x00000806, 0x00037696, "data\\character\\reimu\\reimu.pat"},
	{0x00037E9C, 0x0004445E, "data\\character\\marisa\\marisa.pat"},
	{0x0007C2FA, 0x00034FD5, "data\\character\\sakuya\\sakuya.pat"},
	{0x000B12CF, 0x0002A994, "data\\character\\alice\\alice.pat"},
	{0x000DBC63, 0x0003F846, "data\\character\\patchouli\\patchouli.pat"},
	{0x0011B4A9, 0x0003A491, "data\\character\\youmu\\youmu.pat"},
	{0x0015593A, 0x0003FBFF, "data\\character\\remilia\\remilia.pat"},
	{0x00195539, 0x0002E11F, "data\\character\\yuyuko\\yuyuko.pat"},
	{0x001C3658, 0x00036667, "data\\character\\yukari\\yukari.pat"},
	{0x001F9CBF, 0x0003B42F, "data\\character\\suika\\suika.pat"},
	{0x002350EE, 0x00A44296, "data\\character\\03.dat"},
	{0x00000E5A, 0x00E42C5C, "wave\\bgm\\00a.wav"},
	{0x00E43AB6, 0x00C3F3E4, "wave\\bgm\\00b.wav"},
	{0x01A82E9A, 0x01788970, "wave\\bgm\\00c.wav"},
	{0x0320B80A, 0x00AA9794, "wave\\bgm\\01a.wav"},
	{0x03CB4F9E, 0x00B2F08C, "wave\\bgm\\01b.wav"},
	{0x047E402A, 0x01147594, "wave\\bgm\\02a.wav"},
	{0x0592B5BE, 0x00E8B4A8, "wave\\bgm\\02b.wav"},
	{0x067B6A66, 0x01419604, "wave\\bgm\\03a.wav"},
	{0x07BD006A, 0x00AEA8A8, "wave\\bgm\\03b.wav"},
	{0x086BA912, 0x0116A098, "wave\\bgm\\04a.wav"},
	{0x098249AA, 0x00EDD4A8, "wave\\bgm\\04b.wav"},
	{0x0A701E52, 0x00BE9244, "wave\\bgm\\05a.wav"},
	{0x0B2EB096, 0x00E9E4A8, "wave\\bgm\\05b.wav"},
	{0x0C18953E, 0x00C320EC, "wave\\bgm\\06a.wav"},
	{0x0CDBB62A, 0x0095E9BC, "wave\\bgm\\07a.wav"},
	{0x0D719FE6, 0x018E19A4, "wave\\bgm\\08a.wav"},
	{0x0EFFB98A, 0x02108738, "wave\\bgm\\09a.wav"},
	{0x111040C2, 0x010240A8, "wave\\bgm\\sys00_op.wav"},
	{0x1212816A, 0x00E0F870, "wave\\bgm\\sys99_ed.wav"},
	{0x12F379DA, 0x005B990C, "wave\\bgm\\51.wav"},
	{0x134F12E6, 0x00322AC8, "wave\\bgm\\52.wav"},
	{0x13813DAE, 0x009CCFF4, "wave\\bgm\\53.wav"},
	{0x141E0DA2, 0x00CCBF58, "wave\\bgm\\54.wav"},
	{0x14EACCFA, 0x003C9DB4, "wave\\bgm\\56.wav"},
	{0x15276AAE, 0x0053CA88, "wave\\bgm\\57.wav"},
	{0x157B3536, 0x006BA180, "wave\\bgm\\58.wav"},
	{0x15E6D6B6, 0x0064C804, "wave\\bgm\\59.wav"},
	{0x164B9EBA, 0x006350A8, "wave\\bgm\\60.wav"},
	{0x16AEEF62, 0x006E94A8, "wave\\bgm\\61.wav"},
	{0x171D840A, 0x007E848C, "wave\\bgm\\62.wav"},
	{0x179C0896, 0x0083A8A8, "wave\\bgm\\63.wav"},
	{0x181FB13E, 0x0063C0A8, "wave\\bgm\\65.wav"},
	{0x188371E6, 0x007344A8, "wave\\bgm\\67.wav"},
	{0x18F6B68E, 0x008C18A8, "wave\\bgm\\68.wav"},
	{0x00C79384, 0x004A803B, "data\\character\\042.dat"},
	{0x011213BF, 0x00580684, "data\\character\\062.dat"},
	{0x016A1A43, 0x0057E1E3, "data\\character\\072.dat"},
	{0x01C1FC26, 0x00004429, "data\\character\\youmu\\youmu.sce"},
	{0x01C2404F, 0x00004329, "data\\character\\patchouli\\patchouli.sce"},
	{0x01C28378, 0x00000BB3, "data\\character\\alice\\cardlist.dat"},
	{0x01C28F2B, 0x0000255E, "musicroom.dat"},
	{0x01C2B489, 0x0178190D, "data\\system\\selectchar.dat"},
	{0, 0, ""},		// EOF(K{)
};

// vg^Cv錾
void dec_filename(const char* path, char* dir, char* title);
void makedir(char* dir);

// C
int main()
{
	char title[MAX_PATH], dir[MAX_PATH], curdir[MAX_PATH];

	GetCurrentDirectory(sizeof(curdir), curdir);

	FILE* fin = fopen("th075b.dat", "rb");
	if(!fin){
		printf("File not found");
		return 0;
	}

	int pos = 0;
	while(DatInfo[pos].offset!=0){
		ARCINFO info = DatInfo[pos];
		printf("%s -> ", info.name);		// is

		char* buf = new char[info.size];
		fseek(fin, info.offset, SEEK_SET);
		fread(buf, info.size, 1, fin);
		sprintf(dir, "%s\\", curdir);
		dec_filename(info.name, dir+strlen(dir), title);

		if(strlen(dir))	makedir(dir);
		FILE* fout = fopen(info.name, "wb");
		if(fout){
			fwrite(buf, info.size, 1, fout);
			fclose(fout);
			printf("OK\n");
		}
		else{
			printf("File write error\n");
		}
		delete[] buf;
		pos++;
	}
	fclose(fin);

	return 0;
}

// ΃pXfBNgƃt@C؂o
void dec_filename(const char* path, char* dir, char* title)
{
	char* pdest = strrchr(path,'\\');
	if(pdest){
		strncpy(title,pdest+1,strlen(path)-(pdest-path));
		memset( title+strlen(path)-(pdest-path)-1,0,1);

		strncpy(dir, path, pdest-path);
		memset( dir+(pdest-path),0,1);
	}
	else{
		strcpy(title,path);
		strcpy(dir, "");
	}
}

// fBNg쐬(r̃pXS⊮)
void makedir(char* dir)
{
	DWORD ret = GetFileAttributes(dir);
	if((ret != 0xFFFFFFFF) && (ret & FILE_ATTRIBUTE_DIRECTORY)!=0);
	else if(CreateDirectory(dir, NULL)==0){
		char  ss[MAX_PATH], *end;
		char* p1 = strrchr(dir,'\\');
		char* p2 = strrchr(dir,'/');
		if(p1>p2)	end = p1;
		else		end = p2;
		int length = end-dir;
		if(length>0){
			ZeroMemory(ss, sizeof(ss));
			memcpy(ss, dir, length);
			makedir(ss);
			makedir(dir);
		}
	}
}
